<?php session_start();  
  header ("HTTP/1.1 200 OK");
  if (isset($_GET["joborder"])) $joborder = @$_GET["joborder"];
  if (isset($_GET["jobtype"])) $jobordtype = @$_GET["jobtype"];

  if (isset($_POST["jobfilter"])) $filter = @$_POST["jobfilter"];
  if (isset($_POST["jobfilter_field"])) $filterfield = @$_POST["jobfilter_field"];
  $wholeonly = false;
  if (isset($_POST["wholeonly"])) $wholeonly = @$_POST["wholeonly"];

  if (!isset($joborder) && isset($_SESSION["joborder"])) $joborder = $_SESSION["joborder"];
  if ($joborder == ""){$joborder="desc";}
  if (!isset($jobordtype) && isset($_SESSION["jobtype"])) $jobordtype = $_SESSION["jobtype"];
  if ($jobordtype == ""){$jobordtype="asc";}
  if (!isset($filter) && isset($_SESSION["jobfilter"])) $filter = $_SESSION["jobfilter"];
  if (!isset($filterfield) && isset($_SESSION["jobfilter_field"])) $filterfield = $_SESSION["jobfilter_field"];
  include 'tcfunctions.php';  
?>

<html>
<head>
<?php htmlheadercontent(); ?>
</head>
<?php
      $conn = connect();
      bodyhtmlheader();
      
      if($_SESSION["logged_in"] == true){
            
      $showrecs = 20;
      $pagerange = 10;

      $a = @$_GET["a"];
      $recid = @$_GET["recid"];

      $page = @$_GET["page"];
      if (!isset($page)){$page =  $_SESSION["jobpage"];}
      if (!isset($page)){$page =  1;}      
      $_SESSION["jobpage"] = $page; 

      $sql = @$_POST["sql"];

      switch ($sql) {
        case "insert":
          sql_insert();
          break;
        case "update":
          sql_update();
          break;
        case "delete":
          sql_delete();
          break;
      }

      switch ($a) {
        case "add":
          addrec();
          break;
        case "edit":
          editrec($recid);
          break;
        case "del":
          deleterec($recid);
          break;
        default:
          select();
          break;
      }

      if (isset($joborder)) $_SESSION["joborder"] = $joborder;
      if (isset($jobordtype)) $_SESSION["jobtype"] = $jobordtype;
      if (isset($filter)) $_SESSION["jobfilter"] = $filter;
      if (isset($filterfield)) $_SESSION["jobfilter_field"] = $filterfield;
      if (isset($wholeonly)) $_SESSION["wholeonly"] = $wholeonly;

      $conn = null;
}?>
<?php bodyhtmlfooter(); ?>
</html>

<?php function select()
  {
  global $a;
  global $showrecs;
  global $page;
  global $filter;
  global $filterfield;
  global $wholeonly;
  global $joborder;
  global $jobordtype;


  if ($a == "reset") {
    $filter = "";
    $filterfield = "";
    $wholeonly = "";
    $page = 1;
    $_SESSION["jobpage"] = $page;              
  }

  $checkstr = "";
  if ($wholeonly) $checkstr = " checked";
  if ($jobordtype == "asc") { $jobordtypestr = "desc"; } else { $jobordtypestr = "asc"; }
  $res = sql_select();
  $count = sql_getrecordcount();
  if ($count % $showrecs != 0) {
    $pagecount = intval($count / $showrecs) + 1;
  }
  else {
    $pagecount = intval($count / $showrecs);
  }
  $startrec = $showrecs * ($page - 1);
    if ($startrec < $count) {
        for ($i = 0; $i < $startrec; $i++) {
            $dummyrow = $res->fetch();
        }
    }   
  $reccount = min($showrecs * $page, $count);
?>

<?php
$browsename = 'Browse Jobs';
browsehtmlheader($browsename);
?>
    <thead>
        <tr>
            <?php if($joborder == "id"){if($jobordtypestr == "asc"){$sortimage = "<img src='images/sortdown.png' title='Decending' border='0'>";}else{$sortimage = "<img src='images/sortup.png' title='Ascending' border='0'>" ;}}else{$sortimage = "" ;} ?>        
            <td class="tableheader2"><?php echo $sortimage?><a href="jobs.php?joborder=<?php echo "id" ?>&jobtype=<?php echo $jobordtypestr ?>"><?php echo htmlspecialchars("ID") ?></a></td>
            <?php if($joborder == "desc"){if($jobordtypestr == "asc"){$sortimage = "<img src='images/sortdown.png' title='Decending' border='0'>";}else{$sortimage = "<img src='images/sortup.png' title='Ascending' border='0'>" ;}}else{$sortimage = "" ;} ?>                    
            <td class="tableheader2"><?php echo $sortimage?><a href="jobs.php?joborder=<?php echo "desc" ?>&jobtype=<?php echo $jobordtypestr ?>"><?php echo htmlspecialchars("Description") ?></a></td>            
            <td>&nbsp;</td>
            <td>&nbsp;</td>            
        </tr>
    </thead>
    <tbody>
        <?php
          for ($i = $startrec; $i < $reccount; $i++)
          {
            $row = sqlite_fetch_array_ex($res);
            $style = "fr";
            if ($i % 2 != 0) {
              $style = "sr";
            }
        ?>        
        <?php setgreenbarrow($browsename, $row["id"]) ?>
            <td class="<?php echo $style ?>"><!--selected,1,rows,1--><?php echo htmlspecialchars($row["id"]) ?></td>
            <td class="<?php echo $style ?>"><!--selected,1,rows,1--><?php echo htmlspecialchars($row["desc"]) ?></td>            
            <td class="<?php echo $style ?>"><!--selected,1,rows,1--><a href="jobs.php?a=edit&recid=<?php echo $i ?>"><img src="images/change.png" title="Change" width="16" height="16" border="0"></a></td>
            <td class="<?php echo $style ?>"><!--selected,1,rows,1--><a href="jobs.php?a=del&recid=<?php echo $i ?>"><img src="images/delete.png" title="Delete" width="16" height="16" border="0"></a></td>                                
        </tr>        
        <?php }?>        
    </tbody>
<?php browsehtmlfooter($browsename, $reccount) ?>
                            
<table class="bd" border="0" cellspacing="1" cellpadding="4">
    <tr>
       <td>
            <a href="jobs.php?a=add"><img src="images/addbtn.png" title="Add a Job" border="0"></a>&nbsp;
       </td>       
    </tr>

    <tr>
        <td>Records shown <?php echo $startrec + 1 ?> - <?php echo $reccount ?> of <?php echo $count ?></td>        
    </tr>
    <tr>
        <td><?php showpagenav($page, $pagecount); ?></td>
    </tr>
</table>
&nbsp;
<hr size="1" noshade>
<form action="jobs.php" method="post">
    <table class="bd" border="0" cellspacing="1" cellpadding="4">
        <tr>
            <td><b>Search for </b>&nbsp;</td>
            <td><input type="text" name="jobfilter" value="<?php echo $filter ?>"/></td>
            <td>&nbsp;<b>in</b>&nbsp; </td>
            <td>
                <select name="jobfilter_field">
                    <option value="">All Fields</option>                    
                    <option value="<?php echo "desc" ?>"<?php if ($filterfield == "desc") { echo " selected=\"selected\" "; } ?>><?php echo htmlspecialchars("Description") ?></option>
                </select>                
            </td>
            <td>                    
                <!--<td><input type="checkbox" name="wholeonly"<?php echo $checkstr ?>>Whole words only</td>-->
                <input type="submit" name="action" title="Search browse for..." value="Search" class="normalbutton"/>&nbsp<input type="button" title="Reset browse after search" value="Reset" onclick="window.location='jobs.php?a=reset'" class="normalbutton"/>
            </td>            
        </tr>
    </table>
</form>                    

<?php } ?>   

<?php function showroweditor($row, $iseditmode)
  {
  global $conn;
  global $a;
  if(isset($iseditmode) && $iseditmode == false){$inputmode = "disabled";}
?>
    <input type="hidden" name="xid" value="<?php echo $row["id"] ?>">
    <input type="hidden" name="pc" value="<?php echo $row["pc"] ?>">
    <table class="tbl" border="0" cellspacing="1" cellpadding="5">       
       <?php if ($a != "add"){ ?>
        <tr>
            <td class="hr"><?php echo htmlspecialchars("ID:")."&nbsp;" ?></td>
            <td class="dr"><input disabled class="il1" type="text" name="id" value="<?php echo str_replace('"', '&quot;', trim($row["id"])) ?>"></td>
        </tr>
         <?php } ?>
        <tr>
            <td class="hr"><?php echo htmlspecialchars("Description:")."&nbsp;" ?></td>
            <td class="dr"><input <?php echo $inputmode ?> class="il2" type="text" name="desc" value="<?php echo str_replace('"', '&quot;', trim($row["desc"])) ?>"></td>
        </tr>
        </table>
<?php } ?>

<?php function showpagenav($page, $pagecount)
    {
  ?>
 <table class="bd" border="0" cellspacing="1" padding-right="4">
    <tr>
        <?php if ($pagecount > 1) { ?>
        <td>
            Pages:&nbsp;
        </td>        
            <?php } ?>
            <?php if ($page > 1)
             {
              ?>
        <td><a href="jobs.php?page=<?php echo $page - 1 ?>">&lt;&lt;&nbsp;Prev</a>&nbsp;</td>
            <?php
             }
              ?>
            <?php
                global $pagerange;

                if ($pagecount > 1) {

                if ($pagecount % $pagerange != 0) {
                $rangecount = intval($pagecount / $pagerange) + 1;
                }
                else {
                $rangecount = intval($pagecount / $pagerange);
                }
                for ($i = 1; $i < $rangecount + 1; $i++) {
                $startpage = (($i - 1) * $pagerange) + 1;
                $count = min($i * $pagerange, $pagecount);

                if ((($page >= $startpage) && ($page <= ($i * $pagerange)))) {
                for ($j = $startpage; $j < $count + 1; $j++) {
                if ($j == $page) {
              ?>
        <td><b><?php echo $j ?></b></td>
            <?php } else { ?>
        <td><a href="jobs.php?page=<?php echo $j ?>"><?php echo $j ?></a></td>
            <?php } } } else { ?>
        <td><a href="jobs.php?page=<?php echo $startpage ?>"><?php echo $startpage ."..." .$count ?></a></td>
            <?php } } } ?>
            <?php if ($page < $pagecount) { ?>
        <td>&nbsp;<a href="jobs.php?page=<?php echo $page + 1 ?>">Next&nbsp;&gt;&gt;</a>&nbsp;</td>
            <?php } ?>
    </tr>
 </table>
 <?php } ?>

<?php function addrec()
{
?>
<?php formhtmlheader('Add Job')?>
    <form name="updatejobtform" enctype="multipart/form-data" action="jobs.php" method="post">
        <input type="hidden" name="sql" value="insert">
        <?php
        $row = array(
          "id" => "",
          "pc" => 2,
          "desc" => "");
        showroweditor($row, true);
        ?>
        <br>
        <input type="submit" name="action" value="Save" class="normalbutton">                                        
        <input type="button" value="Cancel" onclick="window.location='jobs.php'" class="normalbutton">
    </form>                                                                
<?php formhtmlfooter() ?>
<?php } ?>

<?php function editrec($recid)
{
  $res = sql_select();
  $count = sql_getrecordcount();
  sqlite_seek_ex($res, $recid);
  $row = sqlite_fetch_array_ex($res);  
?>
<?php formhtmlheader('Update Job') ?>
        <form name="updatejobtform" enctype="multipart/form-data" action="jobs.php" method="post">
            <input type="hidden" name="sql" value="update">
            <?php showroweditor($row, true); ?>
            <br>  
            <input type="submit" name="action" value="Save" class="normalbutton">                                        
            <input type="button" value="Cancel" onclick="window.location='jobs.php'" class="normalbutton">
        </form>                                                                
<?php formhtmlfooter() ?>
<?php } ?>

<?php function deleterec($recid)
{
  $res = sql_select();
  $count = sql_getrecordcount();
  sqlite_seek_ex($res, $recid);
  $row = sqlite_fetch_array_ex($res);  
?>
<?php formhtmlheader('Delete Job') ?>
        <form name="updatejobtform" action="jobs.php" method="post">
            <input type="hidden" name="sql" value="delete">            
            <?php showroweditor($row, false); ?>
            <br>
            <input type="submit" name="action" value="Delete" class="normalbutton">                                        
            <input type="button" value="Cancel" onclick="window.location='jobs.php'" class="normalbutton">
        </form>
<?php formhtmlfooter() ?>
<?php } ?>


<?php function sql_select()
{
  global $conn;
  global $joborder;
  global $jobordtype;
  global $filter;
  global $filterfield;
  global $wholeonly;

  $filterstr = sqlstr($filter);
  if (!$wholeonly && isset($wholeonly) && $filterstr!='') $filterstr = "%" .$filterstr ."%";
  $sql = "SELECT id, \"desc\", pc FROM job";
  if (isset($filterstr) && $filterstr!='' && isset($filterfield) && $filterfield!='') {
    $sql .= " where " .sqlstr($filterfield) ." like '" .$filterstr ."'";
  } elseif (isset($filterstr) && $filterstr!='') {
    $sql .= " where (id like '" .$filterstr ."') or (\"desc\" like '" .$filterstr ."')";
  }
  if (isset($joborder) && $joborder!='') $sql .= " order by \"" .sqlstr($joborder) ."\"";
  if (isset($jobordtype) && $jobordtype!='') $sql .= " " .sqlstr($jobordtype);
  $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');    
  return $res;
}

function sql_getrecordcount()
{
  global $conn;
  global $joborder;
  global $jobordtype;
  global $filter;
  global $filterfield;
  global $wholeonly;

  $filterstr = sqlstr($filter);
  if (!$wholeonly && isset($wholeonly) && $filterstr!='') $filterstr = "%" .$filterstr ."%";
  $sql = "SELECT COUNT(*) FROM job";
  if (isset($filterstr) && $filterstr!='' && isset($filterfield) && $filterfield!='') {
    $sql .= " where " .sqlstr($filterfield) ." like '" .$filterstr ."'";
  } elseif (isset($filterstr) && $filterstr!='') {
    $sql .= " where (id like '" .$filterstr ."') or (\"desc\" like '" .$filterstr ."')";
  }
  $res = $conn->query($sql) or die('<br/>Error in qeury string:<br/>' .$sql .'<br/>');    
  $row = sqlite_fetch_array_ex($res);
  reset($row);
  return current($row);
}

function sql_insert()
{
  global $conn;
  global $_POST;  
  $sql = "insert into job (\"desc\", pc) values (" .sqlvalue(@$_POST["desc"], true, false) .", " .setpcstatus(@$_POST["pc"]) .")";  
  dbaction($conn,$sql,false);
}

function sql_update()
{
  global $conn;
  global $_POST;  
  $sql = "update job set id=" .sqlvalue(@$_POST["id"], false, false).", \"desc\"=" .sqlvalue(@$_POST["desc"], true, false).", pc=" .setpcstatus(@$_POST["pc"]) ." where " .primarykeycondition();
  dbaction($conn,$sql,false);
}

function sql_delete()
{
  global $conn;

  $sql = "delete from job where " .primarykeycondition();  
  dbaction($conn,$sql,false);
}
function primarykeycondition()
{
  global $_POST;
  $pk = "";
  $pk .= "(id";
  if (@$_POST["xid"] == "") {
    $pk .= " IS NULL";
  }else{
  $pk .= " = " .sqlvalue(@$_POST["xid"], false, false);
  };
  $pk .= ")";
  return $pk;
}


 ?>
